=== debian/changelog ===
proxysql2 (2.5.5) unstable; urgency=medium

  * Update to new upstream release Proxysql 2.5.5-1.1

 -- root <root@de399e185219>  Mon, 21 Aug 2023 10:53:39 +0000

proxysql2 (2.5.5) unstable; urgency=low

  * Initial Release.

 -- EvgeniyPatlan <evgeniy.patlan@percona.com>  mon, 01 Feb 2021 07:41:56 -0400
